#include <stdio.h>
#include <stdlib.h>
#include "bbe251.h"

int main()
{
  unsigned char npstr[8][128][32];
  unsigned char pstr[8][128][32];
  unsigned char nstr[8][128][32];
  int batch;
  int i;
  int j;

  for (batch = 0;batch < 8;++batch) {
    for (i = 0;i < 128;++i) for (j = 0;j < 32;++j) npstr[batch][i][j] = random();
    for (i = 0;i < 128;++i) for (j = 0;j < 32;++j) pstr[batch][i][j] = random();
    for (i = 0;i < 128;++i) for (j = 0;j < 32;++j) nstr[batch][i][j] = random();
  }

  for (batch = 0;batch < 8;++batch) {
    bbe251(npstr[batch],pstr[batch],nstr[batch]);
  }
  
  printf("K.<t>=GF(2^251)\n");
  printf("d=t^57+t^54+t^44+1\n");
  printf("L.<r>=PolynomialRing(K)\n");
  printf("def HT(c): return sum(c^(2^(2*i)) for i in range(126))\n");
  printf("\n");

  for (batch = 0;batch < 8;++batch)
    for (i = 0;i < 128;++i) {
      printf("n=0");
      for (j = 0;j < 251;++j) if (nstr[batch][i][j / 8] & (1 << (j & 7))) printf("+2^%d",j);
      printf("\n");
      printf("w=0");
      for (j = 0;j < 251;++j) if (pstr[batch][i][j / 8] & (1 << (j & 7))) printf("+t^%d",j);
      printf("\n");
      printf("nw=0");
      for (j = 0;j < 251;++j) if (npstr[batch][i][j / 8] & (1 << (j & 7))) printf("+t^%d",j);
      printf("\n");
  
      printf("x=HT((w+w^2)*HT(d/(w+w^2)))\n");
      printf("y=w-x\n");
      printf("if d*(x+x^2+y+y^2)==(x+x^2)*(y+y^2):\n");
      printf("  u=d^3*(x+y)/(x*y+d*(x+y))\n");
      printf("  v=d^3*(x/(x*y+d*(x+y))+d+1)\n");
      printf("  print v^2 + u*v + u^3 + (d^2 + d)*u^2 + d^8\n");
      printf("  E = EllipticCurve(K,[1,d^2+d,0,0,d^8])\n");
      printf("  nuv = n*E([u,v])\n");
      printf("  nu = nuv[0]\n");
      printf("  nv = nuv[1]\n");
      printf("  nx = d*(nu+d^2)/(nu+nv+(d^2+d)*d^2)\n");
      printf("  ny = d*(nu+d^2)/(nv+(d^2+d)*d^2)\n");
      printf("  print d*(nx+nx^2+ny+ny^2)-(nx+nx^2)*(ny+ny^2)\n");
      printf("  print nx+ny-nw\n");
      printf("\n");
    }

  return 0;
}
